import { FormGroup } from '@angular/forms';
import { Field } from '../models/Field';
import { Component, Input, OnInit } from '@angular/core';
import { AutocompleteData } from '../models/DataField/AutocompleteData';
import { FormArray } from '@angular/forms/src/model';
import { JsonSerializer } from '../utilities/JsonSerializer';

@Component({
    selector: 'autocomplete-component',
    templateUrl: './autocomplete-component.html'
})
export class AutocompleteComponent implements OnInit{
    @Input() dataModel: Field;
    @Input() form: FormGroup;
    private data:AutocompleteData = new AutocompleteData(); 
    
    ngOnInit(){
        this.data.type= "autocomplete";
        let autocomplete: AutocompleteData = new AutocompleteData();
        this.dataModel.data =  new JsonSerializer<AutocompleteData>().fromJSONObject(this.data,AutocompleteData);
        //(<FormArray>this.form.get("data")).push(autocomplete.buildForm());
        if (this.form.get("data")) this.form.removeControl("data");
        this.form.addControl("data", this.data.buildForm());
    }
}