import { Component, Input } from '@angular/core';
import { FormGroup, FormControl } from '@angular/forms';
import { Field } from '../models/Field';
import { Rule } from '../models/Rule';
import { Multiplicity } from '../models/Multiplicity';
import { FormArray } from '@angular/forms/src/model';
import { ComboboxComponent } from '../combobox/combobox-component';

@Component({
  selector: 'field-form',
  templateUrl: './field-form.component.html',
  styleUrls: []
})

export class FieldFormComponent {
  @Input() form: FormGroup;
  @Input() dataModel: Field;
  @Input() showMultiplicity: boolean = true;
  @Input() indexPath: string;
  
  isFieldMultiplicityEnabled: boolean = false;

  constructon() { }

  ngOnInit() {
    console.log("init field")
    // this.addNewRule();
  }

  onIsFieldMultiplicityEnabledChange(isFieldMultiplicityEnabled: boolean) {
    if (!isFieldMultiplicityEnabled) {
      (<FormControl>this.form.get('multiplicity').get("min")).setValue(0);
      (<FormControl>this.form.get('multiplicity').get("max")).setValue(0);
    }
  }

  addNewRule() {
    let rule: Rule = new Rule();
    this.dataModel.visible.rules.push(rule);
    (<FormArray>this.form.get("visible").get("rules")).push(rule.buildForm());
  }

  DeleteRule(index) {
    this.dataModel.visible.rules.splice(index, 1);
    (<FormArray>this.form.get("visible").get("rules")).removeAt(index);
  }
}