import { BaseModel } from './BaseModel';
import { FormBuilder, FormGroup, FormControl } from '@angular/forms';
import { FormGenerator } from './interfaces/FormGenerator';
import { JsonSerializer } from '../utilities/JsonSerializer';
import { Section } from './Section';
import { Serializable } from './interfaces/Serializable';
export class DatasetProfileModel extends BaseModel implements Serializable<DatasetProfileModel>,FormGenerator<FormGroup>{

    public sections:Array<Section> = new Array<Section>();
    public label: string;

    fromJSONObject(item:any):DatasetProfileModel{
        this.sections = new JsonSerializer<Section>().fromJSONArray(item.sections,Section);
        this.label = item.label;
        return this;
    }

    buildForm():FormGroup{
        let formGroup:FormGroup = new FormBuilder().group({});
        let sectionsFormArray = new Array<FormGroup>();
        this.sections.forEach(item => {
            let form: FormGroup = item.buildForm();
            sectionsFormArray.push(form)
        })
        formGroup.addControl('sections', this.formBuilder.array(sectionsFormArray));
        formGroup.addControl('label', new FormControl(this.label));
        return formGroup;
    }

}