package dao.entities;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.persistence.TypedQuery;

import org.hibernate.query.Query;

import dao.JpaDao;
import entities.DMP;
import entities.Project;
import entities.UserInfo;
import entities.responses.IDLabelPair;

public class DMPDaoImpl extends JpaDao<DMP, UUID> implements DMPDao {

	public DMP loadDetails(DMP t) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<UUID> listAllIDs() {
		String queryString = "SELECT dmp.id FROM DMP dmp where dmp.status>=0";
		TypedQuery<UUID> typedQuery = entityManager.createQuery(queryString, UUID.class);
		return typedQuery.getResultList();
	}
	
	
	@Override
	public List<IDLabelPair> listAllIDsLabels() {
		String queryString = "SELECT dmp.id, dmp.label FROM DMP dmp where dmp.status>=0";
		Query query = (Query) entityManager.createQuery(queryString);
		List<Object[]> rows = query.list();
		return rows.stream().map(row -> {
			return new IDLabelPair(row[0].toString(), row[1].toString());
		})
		.collect(Collectors.toList());
	}

	@Override
	public List<DMP> getDMPsOfUser(String userID) {
		
		String queryString = "select dmp from DMP dmp where dmp.creator.id=:userid and dmp.status >= 0";
		TypedQuery<DMP> typedQuery = entityManager.createQuery(queryString, DMP.class);
		typedQuery.setParameter("userid", UUID.fromString(userID));
		try {
			return typedQuery.getResultList();
		}
		catch(Exception ex) { //no need to distinguish between exceptions for the moment
			ex.printStackTrace();
			return null;
		}
		
		
	}


	

}
