package dao.entities;

import java.util.List;
import java.util.UUID;

import dao.Dao;
import entities.Registry;
import entities.Researcher;
import entities.responses.IDLabelPair;
import models.criteria.Criteria;

public interface ResearcherDao extends Dao<Researcher, UUID> {

	List<UUID> listAllIDs();

	List<IDLabelPair> listAllIDsLabels();
	
	Researcher getResearcherByEmail(String email);

	List<Researcher> listBy(Criteria<Researcher> criteria);


}