package dao.entities;

import java.util.List;
import java.util.UUID;

import dao.Dao;
import entities.DMP;
import entities.UserInfo;

public interface UserInfoDao extends Dao<UserInfo, UUID> {

	public UserInfo getUserInfo(String userID);
	
	public UserInfo getByIdAndMail(String id, String email);

	public UserInfo getByMail(String email);
	
	public UserInfo getByAuthenticationId(String authentication);
	
	public UserInfo getByUsername(String username);
	
	public List<DMP> getDmpsOfUser(String userID);
	
}