package entities.xmlmodels.modeldefinition;

import java.util.LinkedList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import utilities.XmlSerializable;
import utilities.builders.XmlBuilder;

public class FieldGroup implements DatabaseModelDefinition,XmlSerializable<FieldGroup>{
	private List<FieldSet> fieldSets;

	public List<FieldSet> getFieldSets() {
		return fieldSets;
	}

	public void setFieldSets(List<FieldSet> fieldSets) {
		this.fieldSets = fieldSets;
	}

	@Override
	public Element toXml(Document doc) {
		Element rootElement = doc.createElement("root");
		Element fieldSetsElement = doc.createElement("fieldSets");
		for(FieldSet fieldSet : fieldSets){
			fieldSetsElement.appendChild(fieldSet.toXml(doc));
		}
		rootElement.appendChild(fieldSetsElement);	
		doc.appendChild(rootElement);
		return rootElement;
	}

	@Override
	public FieldGroup fromXml(Element element) {
		this.fieldSets = new LinkedList();
		Element fieldSets = (Element)XmlBuilder.getNodeFromListByTagName(element.getChildNodes(), "fieldSets");

		if(fieldSets!=null){
			NodeList fieldSetElements = fieldSets.getChildNodes();
			for (int temp = 0; temp < fieldSetElements.getLength(); temp++) {
				Node fieldSetElement = fieldSetElements.item(temp);				
				if (fieldSetElement.getNodeType() == Node.ELEMENT_NODE) {
					this.fieldSets.add(new FieldSet().fromXml((Element)fieldSetElement));
				}
			}
		} 
		return this;
	}
	
	
	
}
