package entities.xmlmodels.viewstyledefinition;

import java.util.LinkedList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import entities.xmlmodels.modeldefinition.FieldSet;
import utilities.XmlSerializable;
import utilities.builders.XmlBuilder;

public class ViewStyleModel implements XmlSerializable<ViewStyleModel>{
	private List<Section> sections;

	public List<Section> getSections() {
		return sections;
	}

	public void setSections(List<Section> sections) {
		this.sections = sections;
	}

	@Override
	public Element toXml(Document doc) {
		Element root = doc.createElement("root");
		Element sections = doc.createElement("sections");
		
		for(Section section: this.sections){
			sections.appendChild(section.toXml(doc));
		}
		
		root.appendChild(sections);
		return root;
	}

	@Override
	public ViewStyleModel fromXml(Element element) {
		
		this.sections = new LinkedList();
		Element sections = (Element)XmlBuilder.getNodeFromListByTagName(element.getChildNodes(), "sections");
		if(sections!=null){
			NodeList sectionElements = sections.getChildNodes();
			for (int temp = 0; temp < sectionElements.getLength(); temp++) {
				Node sectionElement = sectionElements.item(temp);				
				if (sectionElement.getNodeType() == Node.ELEMENT_NODE) {
					this.sections.add(new Section().fromXml((Element)sectionElement));
				}
			}
		} 
		return this;
	}
	
	
}
