package models.components.commons.datafield;

import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import utilities.XmlSerializable;

public class CheckBoxData extends FieldData<CheckBoxData>{
	private String label;

	
	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	@Override
	public Element toXml(Document doc) {
		Element root = doc.createElement("data");
		root.setAttribute("label", this.label);
		return root;
	}

	@Override
	public CheckBoxData fromXml(Element item) {
		this.label = item!=null?item.getAttribute("label"):""; //TODO
		return this;
	}

	@Override
	public CheckBoxData fromData(Object data) {
		if(data!=null){
			this.label= (String)((Map<String,Object>)data).get("label");
		}
		return this;
	}

	@Override
	public Object toData() {
		// TODO Auto-generated method stub
		return null;
	}

}
