package models.dataset;

import models.DataModel;

import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.UUID;

public class Dataset implements DataModel<entities.Dataset>{
	private UUID id;
    private String label;
    private String reference;
    private String uri;
    private short status;
    private String properties;
    private List<Registry> registries;
	private List<Service> services;
	private List<DataRepository> dataRepositories;
		
	public UUID getId() {
		return id;
	}
	public void setId(UUID id) {
		this.id = id;
	}
	public String getLabel() {
		return label;
	}
	public void setLabel(String label) {
		this.label = label;
	}
	public String getReference() {
		return reference;
	}
		
	public void setReference(String reference) {
		this.reference = reference;
	}
	public String getUri() {
		return uri;
	}
	public void setUri(String uri) {
		this.uri = uri;
	}
	public short getStatus() {
		return status;
	}
	public void setStatus(short status) {
		this.status = status;
	}
	public String getProperties() {
		return properties;
	}
	public void setProperties(String properties) {
		this.properties = properties;
	}
	public List<Registry> getRegistries() {
		return registries;
	}
	public void setRegistries(List<Registry> registries) {
		this.registries = registries;
	}
	public List<Service> getServices() {
		return services;
	}
	public void setServices(List<Service> services) {
		this.services = services;
	}
	public List<DataRepository> getDataRepositories() {
		return dataRepositories;
	}
	public void setDataRepositories(List<DataRepository> dataRepositories) {
		this.dataRepositories = dataRepositories;
	}	
	
	public void fromDataModel(entities.Dataset entity){
		
	}
	
	public entities.Dataset toDataModel(){
		entities.Dataset entity = new entities.Dataset();
		entity.setId(this.id);
		entity.setLabel(this.label);
		entity.setReference(this.reference);
		entity.setUri(this.uri);
		entity.setProperties(this.properties);
		entity.setStatus(this.status);
		
		if(!this.registries.isEmpty()){
			entity.setRegistries(new HashSet<entities.Registry>());
			for(Registry registry:this.registries){
				entity.getRegistries().add(registry.toDataModel());
			}
		}
				
		if(!this.dataRepositories.isEmpty()){
			entity.setDataRepositories(new HashSet<entities.DataRepository>());
			for(DataRepository dataRepository:this.dataRepositories){
				entity.getDataRepositories().add(dataRepository.toDataModel());
			}
		}
		
		if(!this.services.isEmpty()){
			entity.setServices(new HashSet<entities.Service>());
			for(Service service:this.services){
				entity.getServices().add(service.toDataModel());
			}
		}
		
		
		return entity;
	}
	
}
