package models.dmp;

import models.DataModel;

import java.util.Date;

public class Organisation implements DataModel<entities.Organisation> {
    private String pid;
    private String name;
    private String uri;
    private int status;

    public String getPid() {
        return pid;
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    @Override
    public void fromDataModel(entities.Organisation entity) {
        this.pid = entity.getReference();
        this.name = entity.getLabel();
        this.uri = entity.getUri();
    }

    @Override
    public entities.Organisation toDataModel() {
        entities.Organisation organisationEntity = new entities.Organisation();
        organisationEntity.setReference(this.pid);
        organisationEntity.setLabel(this.name);
        organisationEntity.setUri(this.uri);
        organisationEntity.setCreated(new Date());
        organisationEntity.setStatus((short)this.status);
        return organisationEntity;
    }
}
