package utilities.builders;

import entities.DataEntity;
import models.DataModel;

import java.util.LinkedList;
import java.util.List;

public class DomainModelConverter<T extends DataEntity,U extends DataModel<T>> {

    public List<T> toDataModel(List<U> models){
        List<T> entities = new LinkedList<>();
        for(U model : models){
            entities.add(model.toDataModel());
        }
        return entities;
    }

    public List<U> fromDataModel(List<T> entities,Class<U> clazz) throws IllegalAccessException, InstantiationException {
        List<U> models = new LinkedList<>();
        for(T entity:entities){
            U model = clazz.newInstance();
            model.fromDataModel(entity);
            models.add(model);
        }
        return models;
    }
}
