<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri = "http://java.sun.com/jsp/jstl/functions" prefix = "fn" %>
<!DOCTYPE html>
<html lang="en">
<head>
	<title>Digital Management Plans - Backend administration</title>

	<!-- JQUERY -->
	<script	src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js"></script>

	<!-- BOOTSTRAP -->
	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u"	crossorigin="anonymous">
	<!-- Optional theme -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
	<!-- Latest compiled and minified JavaScript -->
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>

	<!-- Json formatter lib -->
	<script src="resources/js/jquery.json-viewer.js"></script>
	<link rel="stylesheet" type="text/css" href="resources/css/jquery.json-viewer.css">
	
	<!-- lib 4 pretty-printing xml and json -->
	<script src="resources/js/vkbeautify.0.99.00.js"></script>
	
	<!-- Nice BS notifications -->
	<script src="resources/js/bootstrap-notify.min.js"></script>
	
	<!-- Project resources (js, css, etc)-->
	<script src="resources/js/home.js"></script>
	<link rel="stylesheet" type="text/css" href="resources/css/home.css">
	

</head>

<body>
	
	
	<div class="col-sm-8">

		<h3>Digital Management Plans - Backend administration</h3>

		<!--begin tabs going in wide content -->
		<ul class="nav nav-tabs content-tabs" id="maincontent" role="tablist">
			<li class="active"><a href="#manage" role="tab" data-toggle="tab">Manage DMPs</a></li>
			<li class=""><a href="#view" role="tab" data-toggle="tab">DMPs Viewer</a></li>
			<li class=""><a href="#create" role="tab" data-toggle="tab">Create a DMP model</a></li>
		</ul>
		<!--/.nav-tabs.content-tabs -->
		
		
		<div class="tab-content">

			<div class="tab-pane fade active in" id="manage">
				<table class="table table-hover">
					<thead>
						<tr>
							<th>id</th>
							<th>Label</th>
							<th>Version</th>
							<th>Project</th>
							<th>Previous</th>
							<th>Content</th>
						</tr>
					</thead>
					<tbody>
						
						<c:forEach items="${DMPs}" var="dmp"> 
							<tr>
								<td>${dmp.id}</td>
								<td>${dmp.label}</td>
								<td>${dmp.version}</td>
								<td>
									<a href="#" data-toggle="tooltip" data-placement="auto bottom" title="${dmp.project}">${dmp.project.id}</a>
								</td>
								<td>${dmp.previous}</td>
								<td style='float: left;'>
									
									<button class="btn btn-default" data-toggle="modal" data-target="#jsonModal" onclick="clickedShow(${fn:escapeXml(dmp)})">
										<span class="glyphicon glyphicon-search"></span>
									</button>

									<!-- 
									<c:set var="currency" value="USD" scope="session" />
									-->
									
									<button type="button" class="btn btn-default" data-toggle="modal" data-target="#edit-dmp-modal-container" onclick="clickedEdit(${fn:escapeXml(dmp)})">
										<span class="glyphicon glyphicon-pencil"></span>
									</button>
									
									<!-- 
									<button class="btn btn-default" onclick="clickedEdit('${dmp.id}')">
										<span class="glyphicon glyphicon-pencil"></span>
									</button>
									 -->
									
									<button class="btn btn-default" onclick="clickedDelete('${dmp.id}')">
										<span class="glyphicon glyphicon-trash"></span>
									</button>
									
								</td>
							</tr>
						</c:forEach>
						
					</tbody>
				</table>
			</div>
			<!--/.tab-pane -->

			<div class="tab-pane fade" id="view">

				<c:forEach items="${DMPs}" var="dmp">
					<div class="well" onclick="loadTile(${fn:escapeXml(dmp)})">
						<a href="#">DMP <span class="badge">${dmp.id}</span></a>
						<div id="tile-${dmp.id}"></div>
					</div>
				</c:forEach>
				
			</div>
			<!--/.tab-pane -->
			
			
			<div class="tab-pane fade" id="create" style="margin-top: 30px; margin-bottom: 30px;">

				<form class="form-inline" method="POST" action="../rest/setDMPByForm">

					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">DatasetProfileRuleset</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="dpr-label" name="DatasetProfileRuleset.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="dpr-definition" name="DatasetProfileRuleset.definition">
							</div>
						</div>
					</div>
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">DatasetProfileViewStyle</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="dpv-label" name="DatasetProfileViewStyle.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="dpv-definition" name="DatasetProfileViewStyle.definition">
							</div>
						</div>
					</div>
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">DatasetProfile</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="dp-label" name="DatasetProfile.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="dp-definition" name="DatasetProfile.definition">
							</div>
						</div>
					</div>

					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">Project</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="p-label" name="Project.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="p-definition" name="Project.definition">
							</div>
							<div class="form-group">
								<label for="reference">Reference:</label> 
								<input type="text" class="form-control" id="p-reference" name="Project.reference">
							</div>
							<div class="form-group">
								<label for="uri">URI:</label> 
								<input type="text" class="form-control" id="p-uri" name="Project.uri">
							</div>
						</div>
					</div>
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">DMPProfile</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="dmpp-label" name="DMPProfile.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="dmpp-definition" name="DMPProfile.definition">
							</div>
						</div>
					</div>
					
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">DMP</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="dmp-label" name="DMP.label">
							</div>
							<div class="form-group">
								<label for="previous">Previous:</label> 
								<input type="text" class="form-control" id="dmp-previous" name="DMP.previous">
							</div>
							<div class="form-group">
								<label for="version">Version:</label> 
								<input type="text" class="form-control" id="dmp-version" name="DMP.version">
							</div>
							<div class="form-group">
								<label for="profileData">Profile Data:</label> 
								<input type="text" class="form-control" id="dmp-profileData" name="DMP.profileData">
							</div>
						</div>
					</div>
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">DataRepository</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="drep-label" name="DataRepository.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="drep-definition" name="DataRepository.definition">
							</div>
							<div class="form-group">
								<label for="reference">Reference:</label> 
								<input type="text" class="form-control" id="drep-reference" name="DataRepository.reference">
							</div>
							<div class="form-group">
								<label for="uri">URI:</label> 
								<input type="text" class="form-control" id="drep-uri" name="DataRepository.uri">
							</div>
							<div class="form-group">
								<label for="abbr">Abbreviation:</label> 
								<input type="text" class="form-control" id="drep-abbr" name="DataRepository.abbr">
							</div>
						</div>
					</div>
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">Registry</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="reg-label" name="Registry.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="reg-definition" name="Registry.definition">
							</div>
							<div class="form-group">
								<label for="reference">Reference:</label> 
								<input type="text" class="form-control" id="reg-reference" name="Registry.reference">
							</div>
							<div class="form-group">
								<label for="uri">URI:</label> 
								<input type="text" class="form-control" id="reg-uri" name="Registry.uri">
							</div>
							<div class="form-group">
								<label for="abbr">Abbreviation:</label> 
								<input type="text" class="form-control" id="reg-abbr" name="Registry.abbr">
							</div>
						</div>
					</div>
					
					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">Service</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="s-label" name="Service.label">
							</div>
							<div class="form-group">
								<label for="definition">Definition:</label> 
								<input type="text" class="form-control" id="s-definition" name="Service.definition">
							</div>
							<div class="form-group">
								<label for="reference">Reference:</label> 
								<input type="text" class="form-control" id="s-reference" name="Service.reference">
							</div>
							<div class="form-group">
								<label for="uri">URI:</label> 
								<input type="text" class="form-control" id="s-uri" name="Service.uri">
							</div>
							<div class="form-group">
								<label for="abbr">Abbreviation:</label> 
								<input type="text" class="form-control" id="s-abbr" name="Service.abbr">
							</div>
						</div>
					</div>

					<div class="panel panel-default">
						<div class="panel-heading">
							<h3 class="panel-title">Dataset</h3>
						</div>
						<div class="panel-body">
							<div class="form-group">
								<label for="label">Label:</label> 
								<input type="text" class="form-control" id="datas-label" name="Dataset.label">
							</div>
							<div class="form-group">
								<label for="uri">URI:</label> 
								<input type="text" class="form-control" id="datas-uri" name="Dataset.uri">
							</div>
							<div class="form-group">
								<label for="props">Properties:</label> 
								<input type="text" class="form-control" id="datas-props" name="Dataset.props">
							</div>
						</div>
					</div>
				
				    <button type="submit" class="btn btn-default">Create</button> <button type="button" class="btn">Cancel</button>
				  </form>
				
			</div>
			<!--/.tab-pane -->
			

		</div>
		<!--/.tab-content -->

	</div>


	<div id="jsonModal" class="modal fade" role="dialog">
		<div class="modal-dialog">

			<!-- Modal content-->
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal">&times;</button>
					<h4 class="modal-title">DMP view</h4>
				</div>
				<div class="modal-body">
					<p></p>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				</div>
			</div>

		</div>
	</div>
	
	
	<!-- Modal -->
	<div class="modal fade" id="edit-dmp-modal-container" tabindex="-1" role="dialog" aria-labelledby="edit-dmp-modal-container" aria-hidden="true">
	  <div class="modal-dialog" role="document">
	    <div class="modal-content">
	      <div class="modal-header">
	        <h3 class="modal-title" id="edit-dmp-modal">Edit DMP</h3>
	        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
	          <span aria-hidden="true">&times;</span>
	        </button>
	      </div>
	      <div class="modal-body">
	        <form id="edit-dmp-form"class="form-inline" method="POST" action="../rest/editDMPByForm">


				<input type="hidden" form="edit-dmp-form" class="form-control" id="dmp-id" name="dmp-id" value="">

				<div class="form-group">
					<label for="definition">DatasetProfile Definition:</label> 
					<textarea rows="12" cols="60" form="edit-dmp-form" class="form-control" id="dp-definition" name="DatasetProfile.definition"></textarea>
				</div>
				
				<div class="form-group">
					<label for="definition">DatasetProfileRuleset Definition:</label> 
					<textarea rows="12" cols="60" form="edit-dmp-form" class="form-control" id="dpr-definition" name="DatasetProfileRuleset.definition"></textarea>
				</div>
				
				<div class="form-group">
					<label for="definition">DatasetProfileViewStyle Definition:</label> 
					<textarea rows="12" cols="60" form="edit-dmp-form" class="form-control" id="dpv-definition" name="DatasetProfileViewStyle.definition"></textarea>
				</div>
	
				
				
			    <button type="submit" class="btn btn-primary">Update</button>
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
				    
			  </form>
	        
	        
	      </div>
	      <div class="modal-footer">
	      <!-- 
	        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
	        <button type="button" class="btn btn-primary">Save changes</button>
	       -->
	      </div>
	    </div>
	  </div>
	</div>

	
	
	
</body>
</html>