import { PaginationService } from './form/pagination/pagination-service';
import {
    TableOfContentsFieldComponent,
} from './form/tableOfContents/table-of-content-field/table-of-content-field.component';
import { ProgressBarComponent } from './form/pprogress-bar/progress-bar.component';
import {
    TableOfContentsSectionComponent,
} from './form/tableOfContents/table-of-content-section/table-of-content-section.component';
import {
    TableOfContentsGroupComponent,
} from './form/tableOfContents/table-of-content-group/table-of-content-group.component';
import {
    TableOfContentsFieldSetComponent,
} from './form/tableOfContents/table-of-content-fieldset/table-of-content-fieldset.component';
import { TableOfContentsComponent } from './form/tableOfContents/table-of-contents.component';
import {
    DynamicFieldRadioBoxComponent,
} from './form/dynamic-fields/dynamic-field-radiobox/dynamic-field-radiobox.component';
import {
    DynamicFieldBooleanDecisionComponent,
} from './form/dynamic-fields/dynamic-field-boolean-decision/dynamic-field-boolean-decision.component';
import { AutocompleteRemoteComponent } from './form/dynamic-fields/dynamic-field-autocomplete/autocomplete-remote.component';
import { DynamicFieldDropdownComponent } from './form/dynamic-fields/dynamic-field-dropdown/dynamic-field-dropdown';
import { DynamicFieldCheckBoxComponent } from './form/dynamic-fields/dynamic-field-checkbox/dynamic-field-checkbox';
import { VisibilityRulesService } from './visibility-rules/visibility-rules.service';
import { DynamicFormSectionComponent } from './form/dynamic-form-section/dynamic-form-section';
import { DynamicFormCompositeFieldComponent } from './form/dynamic-form-composite-field/dynamic-form-composite-field';
import { BrowserModule } from '@angular/platform-browser';
import { NgModule, forwardRef } from '@angular/core';
import { FormsModule, ReactiveFormsModule, NG_VALUE_ACCESSOR } from '@angular/forms';
import { HttpClientModule } from '@angular/common/http';
import { HttpModule } from '@angular/http';
import { RouterModule, Routes, Router } from '@angular/router';
//import {DataTableModule } from 'angular-4-data-table-bootstrap-4';
import { DataTableModule } from "angular2-datatable";

import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { AppComponent } from './app.component';
import { RestBase } from './services/rest-base';
import { DynamicFormComponent } from './form/dynamic-form.component';
import { DynamicFormFieldComponent } from './form/dynamic-fields/dynamic-form-field.component';
import { ServerService } from './services/server.service';
import { GlobalVariables } from './services/global-variables.service';
import { TokenService, TokenProvider } from './services/login/token.service';
import { LocalStorageService } from 'ngx-webstorage';
import { DynamicFormGroupComponent } from './form/dynamic-form-group/dynamic-form-group.component';
import { AppRoutingModule } from './app-routing.module';
import { AuthGuard } from './guards/auth.guard';
import { PageNotFoundComponent } from './not-found.component';
import { HomepageComponent } from './homepage/homepage.component';
import { ConfirmationComponent } from './widgets/confirmation/confirmation.component';


import { EestoreService } from './services/eestore.service';
import { GlobalInterceptor } from './services/interceptor';
import { PDFService } from './services/transformers/pdf.service';

import { TabModule } from './tabs/tab.module';
import { AngularDraggableModule } from 'angular2-draggable';

import { NativeLoginService } from './services/login/native-login.service';
import { GooggleSignInComponent } from './login/googgle-sign-in/googgle-sign-in.component';
import { MainSignInComponent } from './login/main-sign-in/main-sign-in.component';
import { NguiAutoCompleteModule } from '@ngui/auto-complete';

import { HTTP_INTERCEPTORS } from '@angular/common/http';

import { BreadcrumbModule, PanelModule } from 'primeng/primeng';

import { CommonModule } from '@angular/common';

import { DatasetTableFilterPipe } from './pipes/dataset-table-filter.pipe';
import { DatasetStatusFilterPipe } from './pipes/dataset-status-filter.pipe';
import { DatasetsComponent } from './datasets/dataset.component';


import { DmpComponent } from './dmps/dmp.component';
import { DmpTableFilterPipe } from './pipes/dmp-table-filter.pipe';
import { DmpStatusFilterPipe } from './pipes/dmp-status-filter.pipe';
import { DmpVersionFilterPipe } from './pipes/dmp-version-filter.pipe';


import { ProjectTableFilterPipe } from './pipes/project-table-filter.pipe';
import { ProjectsComponent }  from './projects/projects.component';
import { ModalComponent } from './modal/modal.component';
import { NgDatepickerModule } from 'ng2-datepicker';

import { StatusToString } from './pipes/various/status-to-string';
import { SidebarModule } from 'ng-sidebar';

import { Ng4LoadingSpinnerModule } from 'ng4-loading-spinner';
import { BreadcrumbComponent } from './widgets/breadcrumb/breadcrumb.component';
import { DmpDetailedComponent } from './viewers/dmp-detailed/dmp-detailed.component';
import { ProjectDetailedComponent } from './viewers/project-detailed/project-detailed.component';

import {ProgressBarModule} from 'primeng/primeng';
import {StepsModule,MenuItem} from 'primeng/primeng';
import {CheckboxModule} from 'primeng/primeng';
import {RadioButtonModule} from 'primeng/primeng';
import {AutoCompleteModule} from 'primeng/primeng';

@NgModule({
  declarations: [
    AppComponent,
    DynamicFormComponent,
    DynamicFormFieldComponent,
    DynamicFormGroupComponent,
    DynamicFormCompositeFieldComponent,
    DynamicFieldBooleanDecisionComponent,
    DynamicFieldRadioBoxComponent,
    TableOfContentsComponent,
    TableOfContentsFieldSetComponent,
    TableOfContentsGroupComponent,
    TableOfContentsSectionComponent,
    GooggleSignInComponent,
    MainSignInComponent,
    PageNotFoundComponent,
    HomepageComponent,
    ModalComponent,
    ProjectsComponent,
    DmpComponent,
    DatasetsComponent,
    ConfirmationComponent,
    AutocompleteRemoteComponent,
    DynamicFieldDropdownComponent,
    DynamicFormSectionComponent,
    ProjectTableFilterPipe,
    DmpVersionFilterPipe,
    DmpStatusFilterPipe,
    DmpTableFilterPipe,
    DatasetTableFilterPipe,
    DatasetStatusFilterPipe,
    StatusToString,
    TableOfContentsFieldComponent,
    ProgressBarComponent,
    DynamicFieldCheckBoxComponent,
    BreadcrumbComponent, DmpDetailedComponent, ProjectDetailedComponent
  ],
  imports: [
    BrowserModule,
    ReactiveFormsModule,
    FormsModule,
    HttpModule,
    HttpClientModule,
    TabModule,
    CommonModule,
    AppRoutingModule,
    AngularDraggableModule,
    DataTableModule,
    NgDatepickerModule,
    Ng4LoadingSpinnerModule,
    NguiAutoCompleteModule,
    BreadcrumbModule,
    ProgressBarModule,
    PanelModule,
    BrowserAnimationsModule,
    SidebarModule.forRoot(),
    StepsModule,
    CheckboxModule,
    RadioButtonModule,
    AutoCompleteModule
  ],
  providers: [{
    provide: HTTP_INTERCEPTORS,
    useClass: GlobalInterceptor,
    multi: true,
  },
    ServerService, VisibilityRulesService,PaginationService, GlobalVariables, AuthGuard, TokenService, LocalStorageService, RestBase, EestoreService, NativeLoginService, PDFService
  ],
  bootstrap: [AppComponent]
})
export class AppModule {
  constructor() {
  }
}
