import { FormGroup } from '@angular/forms';
import { JsonSerializer } from '../utilities/JsonSerializer';
import { Serializable } from './interfaces/Serializable';
import { BaseModel } from './BaseModel';
import {Field} from './Field' 
export class CompositeField extends BaseModel implements Serializable<CompositeField> {
    public fields:Array<Field> = new Array<Field>();
    public ordinal:number
    public id:number
    fromJSONObject(item:any):CompositeField{
        
        this.fields = new JsonSerializer<Field>().fromJSONArray(item.fields,Field);
        this.ordinal = item.ordinal;
        this.id = item.id;
        return this;
    }

    buildForm():FormGroup{
        let formGroup = this.formBuilder.group({
            ordinal:this.ordinal
        });

        let fieldsFormArray = new Array<FormGroup>();        
        this.fields.forEach(item => {
            let form: FormGroup = item.buildForm();
            fieldsFormArray.push(form)
        })
        formGroup.addControl('fields', this.formBuilder.array(fieldsFormArray));
        return formGroup;
    }
}