import { Component, OnInit } from '@angular/core';
import { Router, ActivatedRoute, ParamMap, Params } from '@angular/router';
import {Location} from '@angular/common';
import { ServerService } from '../../../app/services/server.service';


import '../../../assets/perfect-scrollbar/perfect-scrollbar.js';
declare var PerfectScrollbar : any;

declare var $ :any;
@Component({
  selector: 'dmp-detailed',
  templateUrl: './dmp-detailed.component.html',
  styleUrls: [
    '../../../assets/perfect-scrollbar/perfect-scrollbar.css',
    './dmp-detailed.component.css'
  ]
})
export class DmpDetailedComponent implements OnInit {

  constructor(private serverService: ServerService, private router: Router, private _location: Location, private route: ActivatedRoute) {
    
  }

  dmp : any;
  previousDMPs : any [] = new Array<any>();

  ngOnInit() {

    let sub = this.route.queryParams.subscribe(params => {

      let dmpid = params.dmpid;
      this.serverService.getDmp(dmpid,true).subscribe(
        response => {
          
          this.dmp = response;
          
          //get also the labels of all previous dmps (not eagerly, just fetch the dmp tuple)
          if(this.dmp.previous != null && this.dmp.previous != ""){
            this.serverService.getDmpHistory(this.dmp.id).subscribe(
              response => {
                this.previousDMPs = response;
              },
              error => {
                console.log("Could not get previous DMPs (history)");
              }
            )
          }
          //fill-in also the creator
          this.serverService.getUserByID(this.dmp.creator).subscribe(
            response => {
              this.dmp.creator = response;
            },
            error => {
              console.log("Could not fetch creator details...");
            }
          )

          
          $('#dmp-details-modal').modal('show');

        },
        error => {
          console.log("Could not load dmp");
        }
      )
      
    });

    var dmpDetailsModalScroller = new PerfectScrollbar("#dmp-modal-content");


  }


  



}
