import { Component, OnInit } from '@angular/core';
import { Router, CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot, ActivatedRoute, NavigationEnd } from '@angular/router';
import {BreadcrumbModule,MenuItem} from 'primeng/primeng';

@Component({
  selector: 'breadcrumb',
  templateUrl: './breadcrumb.component.html',
  styleUrls: ['./breadcrumb.component.css']
})
export class BreadcrumbComponent implements OnInit {


  breadcrumbHome: MenuItem = {icon: 'fa fa-home', routerLink: "/welcome"};
  breadcrumbData: MenuItem[] = new Array<MenuItem>();

  ngOnInit() {
    
  }

  constructor(private router: Router, private route: ActivatedRoute) {
    router.events.subscribe(
      event =>{
        console.log("Router event captured")
        console.log(event)
        if(event instanceof NavigationEnd){
          console.log(event.urlAfterRedirects);
          console.log(this.route);

          this.route.children.forEach( child => {
              let menuItem = this.guessMenuItemFromActivatedRoute(child, event);
              this.adaptBreadcrumbByMenuItem(menuItem);
          })

        }
      });

  }


  guessMenuItemFromActivatedRoute(activatedRoute : any, event : NavigationEnd) { //it's important to leave it as "any"

    let menuItem : MenuItem = null;
    let isBaseComponent : boolean = false;

    let componentName = activatedRoute.component.name; 
    
    let params = activatedRoute.queryParams.getValue();
    let url = activatedRoute.url.getValue()[0].path;
    //let url = event.urlAfterRedirects.split("?")[0].split("(")[0]; 
    let label = null;

    if(componentName == "ProjectsComponent") {
      label = "Projects";
      this.breadcrumbData.length = 0;
    }
    if(componentName == "DmpComponent"){
      label = "My Data Management Plans";
      this.breadcrumbData.length = 0;
    }

    if(componentName == "DatasetsComponent"){
      label = "Datasets of DMP '"+params["label"]+"'";
    }

    if(componentName == "DynamicFormComponent"){
      label = "Form of dataset '"+params["label"]+"'";
    }

    if(componentName == "DmpDetailedComponent"){
      label = "Details of DMP '"+params["label"]+"'";
    }

    if(componentName == "ProjectDetailedComponent"){
      label = "Details of Project '"+params["label"]+"'";
    }

    
    if(label != null)
      menuItem = {"label": label, "routerLink": url, "queryParams" : params };

    console.log("COMPONENT NAME="+componentName);

    return menuItem;
  }


  adaptBreadcrumbByMenuItem(menuItem : MenuItem){

    if(menuItem==null){
      this.breadcrumbData.length = 0;
      return;
    }

    let breadcrumbDataNew: MenuItem[] = new Array<MenuItem>();
    for(var i=0; i<this.breadcrumbData.length;i++){
      if(this.breadcrumbData[i].label == menuItem.label)
        break;  
      else
        breadcrumbDataNew.push(this.breadcrumbData[i]);
    }
    this.breadcrumbData = breadcrumbDataNew;

    this.breadcrumbData.push(menuItem);

  }




}
